#include <stdlib.h>             // for exit(), random()
#ifdef __DOS32__
 #include <tvhelp.h>
 #include <conio.h>
 #include <io.h>
 #include <share.h>
#else
 #include "help.h"
#endif
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>


#ifndef __DOS32__
 #define O_BIN 0x0000
 #define CDECL
 #define near
#else
 #define O_BIN           O_BINARY
 #define CDECL           _cdecl
#endif

#define Uses_TKeys
#define Uses_TApplication
#define Uses_TStatusDef
#define Uses_TStatusItem
#define Uses_TStatusLine
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TMenuItem
#define Uses_TWindow
#define Uses_TDeskTop
#define Uses_TView
#define Uses_TRect
#define Uses_MsgBox
#define Uses_fpstream
#define Uses_TEvent
#define Uses_TScroller
#define Uses_TDialog
#define Uses_TListBox
#define Uses_TCollection
#define Uses_TScrollBar
#define Uses_TButton
#define Uses_TInputLine
#define Uses_TLabel
#define Uses_TMonoSelector
#define Uses_TCheckBoxes
#define Uses_TSItem
#define Uses_TChDirDialog
#define Uses_TSystemError
#define Uses_TFileDialog
#define Uses_TBackground
#define Uses_TIndicator
#define Uses_TMemo
#define Uses_THistory
#define Uses_TFrame
#ifndef __DOS32__
 #define Uses_TGKey
#endif
#include <tv.h>

typedef unsigned char byte;
typedef unsigned short int word;
typedef short int word_s;
typedef unsigned long dword;

typedef int (*funcptr)(void *,TEvent&);

#define  ANALOG      0               // ⨯ pp 
#define  DIGIT       1               // ⨯ pp 
#define  EMPTY       3               //  pp

struct analog
{
 char      cipher [10];      // p pp
 float     min_sc ;          //  p 誠
 float     max_sc ;          // p孨 p 誠
};

struct digit
{
 char      cipher [10];      /* p pp */
 byte      type_par ;
};

struct controller
{
 char      nom_ord ;       //. p浪. p p.  ᯨ᪥
 char      nomcontr ;      // p pp
 char      typcontr ;      // ⨯ pp
 short       period ;     // p筮 p
 char      namfil_A [12];  //  䠩 ..p.
 char      namfil_D [12];  //  䠩 .p.p.
 analog  * a_ptr ;         // 㪠.  ....
 short       num_ap ;     // ⢮ . .p
 digit   * d_ptr ;         // 㪠.  ...p.
 short       num_dp ;     // ⢮ . p.p
};


//struct algobl
// {char      cipher[9];
//  short int func;
//  short int subfunc;
//  struct
//  {
//   char     nameX[9];
//  }vhod[8];
//  float     koef[15];
// };

//struct df_alg
// {
//  char        formula[81];
//  char        inp_form[8][31];
//  char        inp_koeff[15][31];
//  char        inp_coment[3][81];
// };

#pragma pack(2)

struct domine
 {
  char IMJ[8];          //    奬
  word_s N_S;           //    N   ⨪  ⥪ 
  word_s K_S;           //    N   ⨪  ⥪ 
  word_s N_D;           //    N    ⥪ 
  word_s K_D;           //   K N    ⥪ 
  word_s N_O;           //    N   ४  ⥪ 
  word_s K_O;           //    N   ४  ⥪ 
  char IMJ_OS [8];      // ᭮   뫠饩
  word ZN_MS  : 2;      // ਧ 稬 奬
                        // 0-筠 奬;
                        // 1-,뫠  ᭮ ;2- ;
  word Z2     : 4;      // 
 };

struct domineed
 {
  char IMJ[8];          //    奬
  void *stat;           //   ⥫  ⨪ ⥪ 
  void *din;            //   ⥫   ⥪ 
 };

struct dinamika
 {
  char IMJ[10]; /*    ࠬ     */
  word  FOR_DIN :4;  // ꥪ 
  word  FOR_RAS :4;
  word  PR_AVAR :1;  // ᯮ
  word  PR_SIFR :1;
  word  PR_ZN   :1;
  word  PR_OK   :1;  //ਧ , ४᪨ ⥪饣 梥
  word  PR_UP   :1;  //ਧ ࠢ塞
  word  T_S_P   :2;
  word_s Y_MIN;      //न  
  word_s Y_MAX;
  word_s X_MIN;      //न  
  word_s X_MAX;
  word_s X_PRED;
  word  C_ZAP   :5;   // 
  word  C_BOR   :5;   // 
  word  O_ZAP   :5;   //
  word  P_P_Z   :1;   // ᯮ
  word  N_KO    :5;   // ஫
  word  P_E     :1;   // ࠬ
  word  NOM_PAR :10;  //   ᯮ ஫
  word_s X_SIFR;word_s Y_SIFR;
  word_s X_ZN  ;word_s Y_ZN  ;
  word_s X_KUR ;word_s Y_KUR ;
 };

struct statika
 {
  word TIP  :5;
  word STIL :3;
  word COL  :4;
  word OBRA :4;
  word_s s2,s3,s4,s5,s6,s7,s8,s9,s10;
 };

struct statikaed
 {
  char NameStat[12];
  word TIP  :5;
  word STIL :3;
  word COL  :4;
  word OBRA :4;
  word_s s2,s3,s4,s5,s6,s7,s8,s9,s10;
 };

struct db_head
 {
  char ver;           // DBF (def = 3)
  char data[3];         // 䨪樨
  long numb_rec;        //⢮ ᥩ
  short len_head;       // 
  short len_rec;        // 
  char  res[20];
 };

struct db_str_rec
 {
  char name[11];        // 
  char tip_fild;        //  (C - ASCII; N - ; L - ᪨; M - Memo; D - Data)
  long adr_in_mem;
  char len_fild;        // 
  char dec_field;       // ᫥ "."
  char res[14];
 };

struct str8
{
 char name[8];
};

struct str9
{
 char name[9];
};

struct object           // pp ⥫ ꥪ p
{
 char      cipher [10];      // p ꥪ
 char      ciph_ds [10];     // p p⭮ ᨣ
 byte      n_ms ;            // ⢮ 奬
 str8      *ciph_ms;    // p 奬
 byte      n_gr_c ;          // . p㯯 p
 str9      *ciph_gr_c;       // p p㯯 p
 byte      n_gr_g ;          // . p㯯 p䨪
 str9      *ciph_gr_g;       // p p㯯 p䨪
};

class TComboBox;
class TEdit;
class TMyLabel;

struct str20
{
 char name[20];
 char index;
};

struct LabelEl
{
 char activ;            //  EDIT  COMBO   ⨢
 char *NameEl;
 TMyLabel *Labelptr;
};

struct EditEl
{
 int  lenEntr;
 char NameField[11];
 char *EntMsk;
 char *znach;
 float def;
 char option;            // 0-1: 1 -  ।஢; 2 - . ; 3 -  
 TEdit *Editptr;         // 2:  䠩  ᯠ⮢
};                       // 3:  䠩  ᯠ⮢
                         // 4: float
struct ComboEl
{
 int       lenEntr;
 char      NameField[11];
 char      NumbElem;
 str20     *StrElem;
 TEdit     *Editptr;
 TComboBox *Comboptr;
};

struct strelem
{
 char tipElem;
 char ax_n;
 char ay_n;
 char n_el_comb;
 char st_el_comb[10];
 union
 {
  LabelEl Label1;
  EditEl  Edit1;
  ComboEl Combo1;
 };
};

struct tip_contr
{
 char Name[11];
 char NameAn[6];
 char NameDig[6];
 int  NumbElem;
 strelem *Elem;
 int  NumbElemAn;
 strelem *ElemAn;
 int  NumbElemDig;
 strelem *ElemDig;
};


class TCompCollect;

struct frm_str
{
 char name[257];
 char tip;
 TCompCollect *inp;
 TCompCollect *koef;
 char *formul;
};

struct alg_str
{
 char name[10];
 char *disript;
 word form;
 TCompCollect *inp;
 TCompCollect *koef;
};

#pragma pack()


extern char *Text_msg[];

extern char AlgConf[];
extern char NameDfal[];
extern char NameAlgFrm[];
extern char NameDescrCnt[];
extern char NameCntTip[];
extern char NameErr[];
extern char DomineMs[];
extern char StatikaMs[];
extern char DinamikaMs[];
extern char NameGrc[];
extern char NameGrg[];
extern char NameSign[];
extern char NameSign1[];
extern char NameView[];
extern char NameComt[];
extern char NamePCXLib[];
extern char NameWAVLib[];
extern char NameSpk[];
extern char NameFont[];
extern char NameHelp[];

const int cmProtocol      = 200;
const int cmAlgobls1      = 201;
const int cmFindProtocol  = 202;
const int cmDelAlg        = 203;
const int cmFormuls1      = 204;
const int cmTestDialog    = 205;
//const int cmMyChangeDir   = 206;
const int cmMsh           = 207;
const int cmGrc           = 208;
const int cmGrg           = 209;
const int cmSignal        = 210;
const int cmView          = 211;
const int cmCmpt          = 212;
const int cmLib           = 213;
const int cmSpeak         = 214;
const int cmContr         = 215;
const int cmPaspA         = 216;
const int cmPaspD         = 217;
const int cmAllCntr       = 218;
const int cmFill          = 219;

const int cmClustChange   = 231;
const int cmChange        = 232;
const int cmSearch        = 233;
const int cmSearchNext    = 234;
const int cmInsert        = 235;
const int cmDelete        = 236;
const int cmRename        = 237;
const int cmAdd           = 238;
const int cmReLoad        = 239;
const int cmSave1         = 240;
const int cmMove          = 241;

const int cmRes1          = 250;
const int cmRes2          = 251;

const int hlChangeDir = cmChangeDir;

class TMyApp;
extern void DelSpace(char *str,char len);
extern void CDECL DispFixErr(int op,char *fmt, ...);
extern int  chkbound(char *mask,float znach);
extern int NoEdit(void* source,TEvent& event);
extern long filelength_(int hd);
extern int copyfile(int fh, int fh1, int size);
extern ushort inputBoxN( const char *Title, const char *aLabel, char *s, int limit, int hist_id );

extern TMyApp *myApp;

extern const int maxLineLength;
extern const int maxLines;

extern const int cmProtocol;
extern const int cmAlgoblok;
extern const int cmFindProtocol;
extern const int cmDelAlg;

